\ Struct.4th
\ These are some miscellaneous words that I have found useful
\ in defining and linking structures
\ John Kennan
\ 3-18-88

Find Struct4th NOT
   IFTRUE
	: Struct4th ;
	." Compiling Struct.4th" CR
   OTHERWISE
	Prior.Stream
   IFEND

: GetNext ( addr--naddr )  \ in a series of 0 ended string - get next string
	DUP 0$LEN 1+ + =CELLS ;

: Intuitext>Text ( n\textarray\IntuitextArray-- ) \ place ptrs to text in 
	+itIText				  \ intuitext at run time
	ROT 0 DO
		2DUP !
		Intuitext + SWAP GetNext SWAP
	LOOP
	2DROP ;

: CopyStructure ( saddr\daddr\size\n-- )  \ make n copies of structure at saddr
					  \ starting at daddr ( n > 1 )
	1- 0 DO
	  DUP 2OVER ROT CMOVE
	  DUP ROT + SWAP       \ increment destination
	LOOP CMOVE ;
